#!/bin/sh

export USER=`id -u -n`


LOGF=/tmp/$USER-rk3568.sh.log #release
#LOGF=`tty` #debug
exec 2> $LOGF


get_connector_id() {
	xrandr  --verbose | 
		awk 'BEGIN{found = 0} { 
			if($0 ~ /.+ connected primary/) {
				found = 1
			}else if(found == 1 && $1=="CONNECTOR_ID:") {
				print $2
				exit
			}
		}'

}

get_encoder_id() { 
	local CONNECTOR_ID=`get_connector_id`
	echo "CONNECTOR_ID: $CONNECTOR_ID" >> $LOGF
	modeprint rockchip |awk 'BEGIN{found=0}{ 
		if($1 == "Connector:") 
			found=1
		else if(found==1 && $1 == "id") {
			if($3 == '$CONNECTOR_ID')
				found = 2
			else 
				found = 0
		}else if(found==2 && $1 == "encoder") {
			print $4
			exit
		}
	}'

}

#获取当前Crtc ID
get_crtc_id() { 
	local ENCODER_ID=`get_encoder_id`
	echo "ENCODER_ID: $ENCODER_ID" >> $LOGF
	modeprint rockchip |awk 'BEGIN{found=0}{ 
		if($1 == "Encoder:") 
			found=1
		else if(found==1 && $1 == "id") {
			if($2 == "':$ENCODER_ID'")
				found = 2
			else 
				found = 0
		}else if(found==2 && $1 == "crtc_id") {
			print substr($2, 2)
			exit
		}
	}'
}

get_plane_id() {
	local CRTC_ID=`get_crtc_id`
	echo "CRTC_ID: $CRTC_ID" >> $LOGF
	modetest -M rockchip -p |awk 'BEGIN{found=0; plane_id=0} {
		if($0~/^[0-9]+\s+'$CRTC_ID'\s+[0-9]+\s+[0-9]/) { 
			found=1
			plane_id=$1
		} else if(found==1 && $1=="value:") {
			found=0
			if($2=="2") {
				print plane_id
				exit
			}
		}
	}'
}

DRM_CURSOR_CONF=/etc/drm-cursor.conf
TMP_CONF=/var/tmp/drm-cursor.conf

if [ "$USER" = "root"  ]; then
	if [ -e $TMP_CONF ]; then
		PLANE_ID=`cat $TMP_CONF`
		sed -r "s/^prefer-plane=.+/prefer-plane=$PLANE_ID/" $DRM_CURSOR_CONF -i
		#rm $TMP_CONF	
	fi
else
	PLANE_ID=`get_plane_id`
	echo "PLANE_ID: $PLANE_ID" >> $LOGF
	if ! grep "^prefer-plane=$PLANE_ID" $DRM_CURSOR_CONF >/dev/null; then
		echo $PLANE_ID >$TMP_CONF 
		killall ukui-session
	fi

fi
